/*
 * Copyright (C) 1996   Warren Jasper
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

/***************************************************************************
 *
 *  dacwrite.c
 *
 *  This program is used to test the CIO-DDA06/16 Digital to Analog
 *  Linux loadable module(dac).
 *
 ***************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "acl8216.h"

#define BYTE unsigned char
#define WORD unsigned short
#define LONG unsigned long


/***************************************************************************
 *
 *  Global Data
 *
 ***************************************************************************/

char *DevName = "/dev/acl-8216-00";
#if 0
char DevNameIO[20];
int  Count    = 1;
int  NoStop   = 0;
int  Print    = 1;
int  Mode     = 0;
int  Status;

/***************************************************************************
 *
 *  Show user how the command line is used.
 *
 ***************************************************************************/

void Usage( void )
{
    fprintf(stderr, "\n\
Usage: adcread \'options\'\n\
Options:\n\
              [-dev /dev/dac##]  - Specify device file.\n
              [-ct ##]           - Number of samples to write\n
              [-noprint]         - Don't print samples\n
              [-nostop]          - Write forever\n
\n");
    exit(1);
}

/***************************************************************************
 *
 *  Process command line switches
 *
 ***************************************************************************/

void DoCommandLine(int argc, char **argv)
{
int i;

i = 1;

while (i < argc) {
  if (strcmp(argv[i], "-dev") == 0) {
    i++;
    if (i == argc)
      Usage();
    else 
      DevName = argv[i];
  } else if (strcmp(argv[i], "-ct") == 0) {
    i++;
    if (i == argc)
      Usage();
    else 
      Count = atoi(argv[i]);
  } else if (strcmp(argv[i], "-noprint") == 0) {
    Print = 0;
  } else if (strcmp(argv[i], "-nostop") == 0) {
    NoStop = 1;
  } else {
    Usage();
  }
  i++;
}

}

/***************************************************************************
 *
 *  Main
 *
 ***************************************************************************/
#endif

int main(int argc, char **argv)
{
	int i,fd,fd2,fd3,fd4;
	signed short buffer[10]={0};

	if ((fd = open("/dev/acl-8216-00", O_RDWR )) < 0) {
		perror(DevName);
		printf("error opening device %s\n", DevName);
		exit(2);
	}
	if ((fd2 = open("/dev/acl-8216-01", O_RDWR )) < 0) {
		perror("/dev/acl-8216-01");
		printf("error opening device %s\n", "/dev/acl-8216-01");
		exit(2);
	}
	if ((fd3 = open("/dev/acl-8216-02", O_RDWR )) < 0) {
		perror("/dev/acl-8216-02");
		printf("error opening device %s\n", "/dev/acl-8216-02");
		exit(2);
	}
	if ((fd4 = open("/dev/acl-8216-03", O_RDWR )) < 0) {
		perror("/dev/acl-8216-03");
		printf("error opening device %s\n", "/dev/acl-8216-03");
		exit(2);
	}
	printf("%d\n",read(fd,&buffer,2));
	while(1) {
		read(fd,&buffer,2);
		printf("1:%x\t",(int)buffer[0]&0xffff);
		printf("%g\n",buffer[0]/32768.0*10.0);
//		printf("%g\n",buffer[0]/32768.0*20.0);
		read(fd2,&buffer,2);
		printf("2:%x\t",(int)buffer[0]&0xffff);
		printf("%g\n",buffer[0]/32768.0*10.0);
//		printf("%g\n",buffer[0]/32768.0*20.0);
		read(fd3,&buffer,2);
		printf("3:%x\t",(int)buffer[0]&0xffff);
		printf("%g\n",buffer[0]/32768.0*10.0);
//		printf("%g\n",buffer[0]/32768.0*20.0);
		read(fd4,&buffer,2);
		printf("4:%x\t",(int)buffer[0]&0xffff);
		printf("%g\n",buffer[0]/32768.0*10.0);
//		printf("%g\n",buffer[0]/32768.0*20.0);
		usleep(200);
	}

	close(fd);
	close(fd2);
}